/*

	Builds the C module, using no other modules.
	Using autobuild here would result in cylic dependencies
	in the build process.

*/

if (this._ == undefined) load(os.pardir+os.sep+"boot.js");

load('C.js');
load('lowlevel.js');
load('parse_code.js');
load('C_wrapper.js');
load('manip.js');
load('parse_code_link.js');
load('text_code.js');

C.wd=os.getcwd();

/*
  Make temporary wrappers for cpp, ctoxml
*/

if (global._WIN32) {
    os.chdir("ctoxml");
	os.system('nmake /nologo CFG="libctoxml - Win32 '+environment.config+'" /f libctoxml.mak');
	os.system('nmake /nologo CFG="libcpp - Win32 '+environment.config+'" /f libcpp.mak');
	os.system('copy libcpp.h .. > NUL');
	os.system('copy libctoxml.h .. > NUL');
	os.system('copy '+environment.config+'lib\\libcpp.dll .. > NUL');
	os.system('copy '+environment.config+'lib\\libctoxml.dll .. > NUL');
	os.chdir("..");
    os.system('copy ..\\..\\js\\src\\Debug\\js32.lib . > NUL');
	os.system('copy ..\\..\\src\\Debug\\callc.lib . > NUL');

	var cppdl=dl('.\\libcpp.dll');
	var ctoxmldl=dl('.\\libctoxml.dll');
} else {
	os.system("make -C ctoxml");
	os.system("cp ctoxml/libcpp.h ctoxml/libctoxml.h ctoxml/libcpp.so ctoxml/libctoxml.so .");

	var cppdl=dl('./libcpp.so');
	var ctoxmldl=dl('./libctoxml.so');
}

_._cpp=new Pointer("cpp 0 Fc 1 0 i0?2 0C 1 0 i0?0errormsg 2 0 0 i0?0", cppdl);
_._ctoxml=new Pointer("ctoxml 0 Fc 1 0 i0?2 0C 1 0 i0?0errorpos 1 0 i2?0", ctoxmldl);

_.cpp=function(code,errormsg) {
	return _._cpp.call(code,errormsg);
}

_.ctoxml=function(code,errorpos) {
	return _._ctoxml.call(code,errorpos);
}

for each (var h in ['libcpp.h','libctoxml.h']) {
	if (!os.access(h+os.dlext,os.R_OK)) {
		_.puts("Building wrapper for "+h);

		headerfile=_.fopen(h,"r");
		header=new Pointer(1024*100);
		len=_.fread(header,1,1024*100,headerfile);
		_.fclose(headerfile);
		header=header.string(len);

		wrapper=C.C_wrapper(header, dl(os.curdir+os.sep+h.substr(0,h.length-2)+os.dlext));

		wrapperfile=_.fopen(h+".cdbg","w");
		_.fwrite(wrapper,wrapper.length,1,wrapperfile);
		_.fclose(wrapperfile);

		if (global._WIN32)
			os.system('cl /nologo /Tc '+h+'.cdbg js32.lib callc.lib /MD /LD /Fe'+h+'.dll');
		else
			os.system('cc -x c '+h+'.cdbg --shared -o '+h+'.so')
	}
}
