/*

Builds the modules, without assuming that any modules are present to begin with.

*/

// First, initialize a minimal set of os functions

boot();

// Build wrapper generator

_.puts("Entering C");
os.chdir("C");
load("_build.js");
_.puts("Leaving C");
os.chdir("..")

if (global._WIN32) {
	C.call(_,"#include <io.h>",cdl);
} else {
	_.struct={"dirent":new Type(" 0 S5 d_ino 0 i3ud_off 0 i3?d_reclen 0 i1ud_type 0 i0ud_name 1 256 i0?"),
	"stat":new Type(" 0 S17 st_dev 0 s__u_quad_t __pad1 0 i1ust_ino 0 i3ust_mode 0 i2ust_nlink 0 i2ust_uid 0 i2ust_gid 0 i2ust_rdev 0 s__u_quad_t __pad2 0 i1ust_size 0 i3?st_blksize 0 i3?st_blocks 0 i3?st_atim 0 stimespec st_mtim 0 stimespec st_ctim 0 stimespec __unused4 0 i3u__unused5 0 i3u")};
	_._readdir.struct=_.struct;
	_._stat.struct=_.struct;
}

// Wrap standard c libraries

_.puts("Entering os");
os.chdir("os");
load("_build.js");

_.puts("Leaving os");
os.chdir("..");
// Now, we can include os and resolve and begin trusting
// that all functionality is present

dl.call(_,os.curdir+os.sep+"os"+os.sep+"clib.h"+os.dlext);
module.include("os");
module.include("_resolve");

for each (var filename in dir()) {
	if (os.isdir(filename) &&
		filename != "os" &&
		filename != "C" &&
		filename[0] != ".") {
		print("Building ",filename,"\n")
		module.build(filename);
	}
}

var rcfile=C.cpp(read("jsextrc.in"));
rcfile=rcfile.replace(/#[^\n]*\n/g,"");
for (var i=1; i<arguments.length; i+=2) {
	rcfile=rcfile.replace("%"+arguments[i]+"%",arguments[i+1],"g");
}
write("jsextrc",rcfile);
_.exit(0);

/*

Initializes a few C functions which are necessary to build the
first few modules, C and os.

*/

function boot() {
global=this;
/* Link callc directly from source tree */

var usedot=false;

if (global._WIN32) {

if (environment.config==undefined) environment.config="Debug";

for each (var d in [".",".."]) {
	try {
		dl(d+'\\..\\src\\'+environment.config+'\\callc.dll');
		usedot=d;
		break;
	} catch(x) {}
}

cdl=dl("MSVcrt.dll");

} else {

for each (var d in [".",".."]) {
	try {
		dl(d+'/../src/callc.so');
		usedot=d;
		break;
	} catch(x) {}
}

cdl=0;

}

if (global._==undefined) _= {
	New:Pointer,
	sizeof:Pointer.prototype.sizeof
};

/*
  Make temporary wrappers
*/

if (global._WIN32) {
var sep='\\';
_._system=new Pointer("system 0 Fc 0 i2?1 0__command 1 0 i0?0",cdl);
_.__chdir=new Pointer("_chdir 0 Fcchdir 0 i2?1 1chdir 1 0 i0?0",cdl);
_.__getcwd=new Pointer("_getcwd 0 Fcgetcwd 1 0 i0?2 0getcwd 1 0 i0?0getcwd 0 i3u0",cdl);
_.__access=new Pointer("_access 0 Fc 0 i2?2 0__pathname 1 0 i0?0mode 0 i2?0",cdl);
_._fopen=new Pointer("fopen 0 Fc 1 0 s_IO_FILE 2 0__filename 1 0 i0?0__modes 1 0 i0?0",cdl);
_._fclose=new Pointer("fclose 0 Fc 0 i2?1 0__stream 1 0 s_IO_FILE 0",cdl);
_._fread=new Pointer("fread 0 Fc 0 i3u4 0__ptr 1 0 v0__size 0 i3u0__n 0 i3u0__stream 1 0 s_IO_FILE 0",cdl);
_._fwrite=new Pointer("fwrite 0 Fc 0 i3u4 0__ptr 1 0 v0__size 0 i3u0__n 0 i3u0__s 1 0 s_IO_FILE 0",cdl);
_._free=new Pointer("free 0 Fcv1 0__ptr 1 0 v0",cdl);
_.__open=new Pointer("_open 0 Fcopen 0 i2?2 1open 1 0 i0?0open 0 i2?1",cdl);
_.__stat=new Pointer("_stat 0 Fcstat 0 i2?2 1stat 1 0 i0?0stat 1 0 sstat 0",cdl);
//_._fchdir=new Pointer("fchdir 0 Fcfchdir 0 i2?1 0fchdir 0 i2?0",cdl);
_.__close=new Pointer("_close 0 Fcclose 0 i2?1 0close 0 i2?0",cdl);

_.access=_._access=function(pathname, mode) {
	return _.__access.call(pathname, mode);
}
_.free=function(ptr) {
	return _._free.call(ptr);
}
_.stat=_._stat=function(fn,buf) {
	return _.__stat.call(fn,buf);
}
_.open=_._open=function(fn,md) {
	return _.__open.call(fn,md);
}
_.close=_._close=function(fd) {
	return _.__close.call(fd);
}
_.fopen=function(filename,modes) {
	return _._fopen.call(filename,modes);
}
_.fclose=function(stream) {
	return _._fclose.call(stream);
}
_.fread=function(ptr, size, n, stream) {
	return _._fread.call(ptr,size,n,stream);
}
_.fwrite=function(ptr, size, n, stream) {
	return _._fwrite.call(ptr,size,n,stream);
}
_.getcwd=_._getcwd=function(a,b) {
	return _.__getcwd.call(a,b);
}
_.system=function(command) {
	return _._system.call(command);
}
_.readdir=function(d) {
	return _._readdir.call(d);
}
_.opendir=function(d) {
	return _._opendir.call(d);
}
_.closedir=function(d) {
	return _._closedir.call(d);
}
_.chdir=_._chdir=function(d) {
	return _.__chdir.call(d);
}
_._puts=new Pointer("puts 0 Fc 0 i2?1 0__s 1 0 i0?0",cdl);

_.puts=function(s) {
	return _._puts.call(s);
  
}

} else {
var sep='/';
_._system=new Pointer("system 0 Fc 0 i2?1 0__command 1 0 i0?0",cdl);
_._readdir=new Pointer("readdir 0 Fcreaddir 1 0 sdirent 1 0readdir 1 0 s__dirstream 0",cdl);
_._opendir=new Pointer("opendir 0 Fcopendir 1 0 s__dirstream 1 1opendir 1 0 i0?0",cdl);
_._closedir=new Pointer("closedir 0 Fcclosedir 0 i2?1 0closedir 1 0 s__dirstream 0",cdl);
_._chdir=new Pointer("chdir 0 Fcchdir 0 i2?1 1chdir 1 0 i0?0",cdl);
_._getcwd=new Pointer("getcwd 0 Fcgetcwd 1 0 i0?2 0getcwd 1 0 i0?0getcwd 0 i3u0",cdl);
_._access=new Pointer("access 0 Fc 0 i2?2 0__pathname 1 0 i0?0mode 0 i2?0",cdl);
_._fopen=new Pointer("fopen 0 Fc 1 0 s_IO_FILE 2 0__filename 1 0 i0?0__modes 1 0 i0?0",cdl);
_._fclose=new Pointer("fclose 0 Fc 0 i2?1 0__stream 1 0 s_IO_FILE 0",cdl);
_._fread=new Pointer("fread 0 Fc 0 i3u4 0__ptr 1 0 v0__size 0 i3u0__n 0 i3u0__stream 1 0 s_IO_FILE 0",cdl);
_._fwrite=new Pointer("fwrite 0 Fc 0 i3u4 0__ptr 1 0 v0__size 0 i3u0__n 0 i3u0__s 1 0 s_IO_FILE 0",cdl);
_._free=new Pointer("free 0 Fcv1 0__ptr 1 0 v0",cdl);
_._open=new Pointer("open 0 Fcopen 0 i2?2 1open 1 0 i0?0open 0 i2?1",cdl);
_._stat=new Pointer("stat 0 Fcstat 0 i2?2 1stat 1 0 i0?0stat 1 0 sstat 0",cdl);
_._fchdir=new Pointer("fchdir 0 Fcfchdir 0 i2?1 0fchdir 0 i2?0",cdl);
_._close=new Pointer("close 0 Fcclose 0 i2?1 0close 0 i2?0",cdl);

_.fchdir=function(fd) {
	return _._fchdir.call(fd);
}

_.access=function(pathname, mode) {
	return _._access.call(pathname, mode);
}
_.free=function(ptr) {
	return _._free.call(ptr);
}
_.stat=function(fn,buf) {
	return _._stat.call(fn,buf);
}
_.open=function(fn,md) {
	return _._open.call(fn,md);
}
_.close=function(fd) {
	return _._close.call(fd);
}
_.fopen=function(filename,modes) {
	return _._fopen.call(filename,modes);
}
_.fclose=function(stream) {
	return _._fclose.call(stream);
}
_.fread=function(ptr, size, n, stream) {
	return _._fread.call(ptr,size,n,stream);
}
_.fwrite=function(ptr, size, n, stream) {
	return _._fwrite.call(ptr,size,n,stream);
}
_.getcwd=function(a,b) {
	return _._getcwd.call(a,b);
}
_.system=function(command) {
	return _._system.call(command);
}
_.readdir=function(d) {
	return _._readdir.call(d);
}
_.opendir=function(d) {
	return _._opendir.call(d);
}
_.closedir=function(d) {
	return _._closedir.call(d);
}
_.chdir=function(d) {
	return _._chdir.call(d);
}
_._puts=new Pointer("puts 0 Fc 0 i2?1 0__s 1 0 i0?0",cdl);

_.puts=function(s) {
	return _._puts.call(s);
  
}
}

_.R_OK=4;
_.O_RDONLY=0;

load(usedot+sep+'module.js');
os={};
if (global._WIN32) load(usedot+'\\os\\win32.js');
else load(usedot+'/os/posix.js');
load(usedot+sep+'os'+sep+'os.js');

include_path=[os.getcwd()+sep+usedot];
module.include("dir");

}