if (global._WIN32 != undefined) module.autobuild();

if (global._WIN32 != undefined && 
	(!os.exists("Constants.js") ||
	os.stat("Constants.js").mtime <= os.stat("_build.js").mtime)) {

print("Extracting constants from windows.h\n");

win32={};
dl.call(win32, ".\\windows.h.dll");

// classname, styleflags, events, methods
var Classes={
	BUTTON: ["BUTTON", "BS", "BM", "BN"],
	EDIT: ["EDIT", "ES", "EM", "EN"],
	RICHEDIT: [win32.RICHEDIT_CLASS, "ES", "EM", "EN"],
	LISTBOX: ["LISTBOX", "LBS", "LB", "LBN"],
	COMBOBOX: ["COMBOBOX", "CBS", "CB", "CBN"],
	STATIC: ["STATIC", "SS", "STM", "STN"],
	SCROLLBAR: ["SCROLLBAR", "SBS", "SBM"],
	PROGRESS: [win32.PROGRESS_CLASS, "PBS", "PBM"],
	ANIMATE: [win32.ANIMATE_CLASS, undefined, "ACM", "ACN"]
}

var Flags={};

var Extract={
	CHARSET: /(.*)_CHARSET/,
	OUT_PRECIS: /OUT_(.*)_PRECIS/,
	QUALITY: /(.*)_QUALITY/,
	PITCH: /(.*)_PITCH/,
}

var SimpleFlags=["FW","CLIP","FF","WS_EX","WS","WM","CS","SC","CF",
	"MFT", "MFS", "MIIM", "MF", "OFN", "UID", "FR", "WB", "SQL_HANDLE", "SQL"];

for each (var class in Classes) {
	for (var i in class)
		if (i!=0 && class[i]!=undefined)
			SimpleFlags.push(class[i]);
}

for each (var e in SimpleFlags)
	Flags[e]={};

SimpleFlags=new RegExp("^("+SimpleFlags.join("_)|^(")+"_)");

for (var e in Extract)
	Flags[e]={};

for (var sym in win32) {
	var match;
	for (var i in Extract) 
		if (typeof(win32[sym])=="number" && (match=sym.match(Extract[i]))) {
			Flags[i][match[1]]=win32[sym];
			break;
		}
	if ((match=sym.match(SimpleFlags))) {
		for (var i=1; i<match.length; i++)
			if (match[i])
				Flags[match[i].substr(0,match[i].length-1)]
					[sym.substr(match[i].length)]=win32[sym];
	}
}

write("Constants.js","var Classes="+Classes.toSource()+";\n"+
	"var Flags="+Flags.toSource()+";\n");

}
